#!/usr/bin/env python

import sys
sys.path.insert(0, '..')
import time

import kinfxdb
dbi=kinfxdb.dbi

import os 

server=os.environ['INFORMIXSERVER']

print '*'*10,  'Test for kinfxdb module ', '*'*10

database='test'
user='informtest'
password='informtest'

#My test database is ready :) //papa
#db=kinfxdb.connect('@'+server,user,password)
#sql='drop database %s'%database
#c=db.cursor()
#c.execute(sql)
isonline= 0
# tring to connect to database
while 1:
        try:
        	db=kinfxdb.connect(database+'@'+server,user,password)
                break
        except kinfxdb.error, e:
        	if e[0]==-329:
                	print e[1]
                        if raw_input("Create database [y/n]? ") in ['y','Y']:
                        	print 'Creating database "%s"'%database
                                # simply connecting to server without database
                                db=kinfxdb.connect('@'+server,user,password)
                                isonline= db.server=='ON'  # This is 'ON' or 'SE'
                                c=db.cursor()
                                sql='create database "%s" '%database
                                if isonline:
                                        sql=sql+'with log'
                                else:
                                        log=raw_input('Enter log pathname for Informix SE database: ')
                                        sql=sql+'with log in "%s"'%log
                                try:
                                        print sql
                                        c.execute(sql)
                                except kinfxdb.error, e:
                                        if e[0]==-330:
                                                print "Warning! Database already exist"
                                        else:
                                                raise kinfxdb.error, e
                        
                        else:
                        	sys.exit(1)
                        	
                else:
                	print e
                	sys.exit(1)

               
# connecting to newer database
c=db.cursor()

cr_qq_online='create table qq ( \
         q1 char(20), \
         q2 integer, \
         q3 date, \
         q4 datetime year to fraction(2), \
         q5 text )'
         
cr_qq_se='create table qq ( \
         q1 char(20), \
         q2 integer, \
         q3 date, \
         q4 datetime year to fraction(2) )'

print 'Creating table "qq"'
if isonline:
	c.execute(cr_qq_online)
else:
	c.execute(cr_qq_se)

print 'Inserting some stuff into qq'
if isonline:
	param=('q1field', 1976, dbi.dbiDate(time.time()),
        	dbi.dbiDate(time.time())
                #,'Blob'*100 #sorry don't work me //papa
		)
#        c.execute('insert into qq values(?,?,?,?,?)', param)
# I know so blob type not write with 'insert' only 'load from' in informix //papa
        c.execute('insert into qq values(?,?,?,?)', param)
else:
	param=('q1field', 1976, dbi.dbiDate(time.time()),
        	dbi.dbiDate(time.time()))
        c.execute('insert into qq values(?,?,?,?)', param)

print 'selecting from qq'
c.execute('select * from qq')
res=c.fetchall()

print 'Kinfxdb works fine.'
print "Don't forget to delete temporary database kinfxtest. Bye."
	



